local me = CreateFrame("Frame" );

--- Builds a standard tooltip for a control.
function me:ControlOnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT" );
	GameTooltip:SetText(self.tooltipText, nil, nil, nil, nil, 1 );
end

--Debug, EPGP show, Breaktime, PostTo, Threshhold, Legend, miniLevel to show gear for

me.okay = function() 
	ElgohDebug=me.Debug:GetChecked();
	showValues=me.EPGP:GetChecked();
	BreaktimeString=me.Breaktime:GetText();
	miniLevel=tonumber(me.ilvlBox:GetText());
	ElgohChannel=(me.Channelbox:GetText()):lower();
end

me.cancel = function() 
	me.EPGP:SetChecked(showValues);
	me.Debug:SetChecked(ElgohDebug);
	me.Breaktime:SetText(BreaktimeString);
	me.ilvlBox:SetText(miniLevel);
	me.Channelbox:SetText(ElgohChannel);
end

me.default = function() 
	me.EPGP:SetChecked(true);
	me.Debug:SetChecked(false);
	me.Breaktime:SetText("Breaktime! Be back in TIME minutes!");
	me.ilvlBox:SetText("359");
	me.Channelbox:SetText("Self");
end

function Elgoh_CheckChannel(self)
	channel, name= GetChannelName(me.Channelbox:GetText());
	if(channel~=nil) then 
	--green
	else 
	--red
	end
end

function Elgoh_OptionsLoaded()
	me.cancel();
	me.Channelbox:SetScript("OnChar", Elgoh_CheckChannel);
end

me.name = "Elgoh";
me:Hide();

-- Pane title
local Title = me:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge" );
Title:SetPoint( "TOPLEFT", 16, -16 );
Title:SetText("Elgoh");
local SubText = me:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall" );
SubText:SetPoint("TOPLEFT", Title, "BOTTOMLEFT", 0, -8 );
SubText:SetPoint("RIGHT", -32, 0 );
SubText:SetHeight(32);
SubText:SetJustifyH( "LEFT" );
SubText:SetJustifyV( "TOP" );
SubText:SetText("General settings, this part is a work in progress so more settings will be added with each update");

-- Miscellaneous checkboxes
me.Debug = CreateFrame("CheckButton", "ElgohDebugCheckbox", me, "InterfaceOptionsCheckButtonTemplate");
me.Debug:SetPoint( "TOPLEFT", SubText, "BOTTOMLEFT", -2, -8 );
getglobal(me.Debug:GetName() .. "Text"):SetText("Enable Debug Mode");
me.Debug.tooltipText = "Enables Debug Mode";

me.EPGP = CreateFrame("CheckButton", "ElgohEPGPCheckbox", me, "InterfaceOptionsCheckButtonTemplate");
me.EPGP:SetPoint( "TOPLEFT", me.Debug, "BOTTOMLEFT", -0, -8 );
getglobal(me.EPGP:GetName() .. "Text"):SetText("Toggle EPGP Values");
me.EPGP.tooltipText = "Toggles showing of EPGP values in item tooltips";

-- Breaktime
local BreakLabel = me:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
BreakLabel:SetPoint( "TOPLEFT", me.EPGP, "BOTTOMLEFT", -0, -8 );
BreakLabel:SetText("Text to post during /breaktime");

me.Breaktime = CreateFrame("EditBox", "ElgohBreaktimeBox", me, "InputBoxTemplate")
me.Breaktime:SetWidth(400)
me.Breaktime:SetHeight(20)
me.Breaktime:SetPoint("LEFT", BreakLabel, "RIGHT", 10,0);
me.Breaktime:SetAutoFocus(false)
me.Breaktime:SetScript("OnEnterPressed", function() me.Breaktime:ClearFocus(); end)
me.Breaktime.tooltipText="\"TIME\" will be replaced with the time in minutes";
me.Breaktime:SetScript( "OnEnter", me.ControlOnEnter);
me.Breaktime:SetScript( "OnLeave", GameTooltip_Hide);

--ItemLevel
me.ilvlBox = CreateFrame("EditBox", "ElgohilvlBox", me, "InputBoxTemplate")
me.ilvlBox:SetWidth(60)
me.ilvlBox:SetHeight(20)
me.ilvlBox:SetPoint("TOP", me.EPGP, "TOP", 0,0);
me.ilvlBox:SetPoint("LEFT", me.Breaktime, "LEFT", 0,0);
me.ilvlBox:SetAutoFocus(false)
me.ilvlBox:SetJustifyH("CENTER");
me.ilvlBox:SetScript("OnEnterPressed", function() me.ilvlBox:ClearFocus(); end)
me.ilvlBox.tooltipText="The minimum Item Level to display EPGP values for";
me.ilvlBox:SetScript( "OnEnter", me.ControlOnEnter );
me.ilvlBox:SetScript( "OnLeave", GameTooltip_Hide );

-- Channel
local ChannelLabel = me:CreateFontString( nil, "ARTWORK", "GameFontHighlight" );
ChannelLabel:SetPoint( "TOPLEFT", BreakLabel, "BOTTOMLEFT", -0, -8 );
ChannelLabel:SetText("Channel to post text to");

me.Channelbox = CreateFrame("EditBox", "ElgohChannelBox", me, "InputBoxTemplate")
me.Channelbox:SetWidth(100)
me.Channelbox:SetHeight(20)
me.Channelbox:SetPoint("LEFT", me.Breaktime, "LEFT", 0,0);
me.Channelbox:SetPoint("TOP", me.Breaktime, "BOTTOM", 0,0);
me.Channelbox:SetAutoFocus(false)
me.Channelbox:SetScript("OnEnterPressed", function() me.Channelbox:ClearFocus(); end)
me.Channelbox.tooltipText="Raid, Party, Guild, Officer, Say, Self or a custom channel";
me.Channelbox:SetScript( "OnEnter", me.ControlOnEnter);
me.Channelbox:SetScript( "OnLeave", GameTooltip_Hide);

InterfaceOptions_AddCategory(me);

		
-- Elgoh.childpanel = CreateFrame( "Frame", "ElgohChild", Elgoh.panel);
-- Elgoh.childpanel.name = "MyChild";
-- Elgoh.childpanel.parent = Elgoh.panel.name;
-- InterfaceOptions_AddCategory(Elgoh.childpanel)